#!/bin/bash
#
# uidnormalizer.sh
#
# Copyright (C) 2011 Simone Piccardi <piccardi@truelite.it>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program or from the site that you downloaded it
# from; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307   USA
#
set -e

MAXUID=40000
MINUID=1000
LASTS=10

# search for biggest uid under MAXUID (to avoid taking nobody), 
# looking at the LASTS values
for i in $(getent passwd | cut -d : -f3 | sort -n | tail -n $LASTS |tac); do
    if [ $i -lt $MAXUID ]; then
        LASTUID=$i
        break
    fi
done

echo Last Used UID: $LASTUID

DUPUID=$(getent passwd | cut -d : -f3 | sort | uniq -d | grep -v '^0$')

echo Duplicated UID: $DUPUID

NEWUID=$LASTUID
# loop over duplicated UID, reassigning
echo "starting to reassign UID values"
for i in $DUPUID; do
    DUPLUSER=$(getent passwd |  grep ":$i:" | cut -d: -f1 )
    echo "reassigning UID for duplicated value $i"
    for j in $DUPLUSER; do
         NEWUID=$(( $NEWUID + 1 ))
         smbldap-usermod -u $NEWUID $j
	 HOME=$(getent passwd | grep "^$j:" | cut -d: -f6)
	 if [ -d "$HOME" ]; then 
	     chown -R "$j" "$HOME"
	 else
	     echo "Home directory $HOME for user $j do not exixts"
	 fi
    done
done
